<template>
  <v-dialog v-model="show" max-width="600px" class="elevation-1">
    <v-card flat>
      <v-img :src="require('@/assets/logo.svg')" height="250" contain />
      <v-card-title class="justify-center text-h4"> Forecast </v-card-title>
      <v-card-subtitle align="center" class="mt-2"
        >A force control algorithm benchmarking framework from Altair Robotics
        Lab</v-card-subtitle
      >
      <v-card-text>
        <v-tabs centered color="primary" v-model="tab">
          <v-tabs-slider></v-tabs-slider>
          <v-tab>Libraries</v-tab>
          <v-tab>About</v-tab>
          <v-tab>Authors</v-tab>

          <v-tab-item>
            <v-row align="center">
              <v-col cols="6" align="center">
                <v-list dense>
                  <v-list-item
                    v-for="(jsdependency, index) in js_dependencies"
                    :key="'jsdependency' + index"
                  >
                    <v-list-item-content>
                      <v-list-item-title>{{ jsdependency }}</v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                </v-list>
              </v-col>
              <v-col cols="6" align="center">
                <v-list dense>
                  <v-list-item
                    v-for="(pydependency, index) in python_dependencies"
                    :key="'pydependency' + index"
                  >
                    <v-list-item-content>
                      <v-list-item-title>{{ pydependency }}</v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                </v-list></v-col
              >
            </v-row>
          </v-tab-item>

          <v-tab-item>
            <v-row align="center" class="mt-5">
              <v-col cols="12" align="center"
                ><p style="font-size: 2em">{{ version }}</p></v-col
              >
              <v-col cols="12" align="center">
                <p>Copyright © 2021 Altair Robotics Laboratory</p>
                <p>
                  This program comes with absolutely no warranty. See the MIT
                  License for details.
                </p></v-col
              ><!-- TODO
              <v-col align="center" cols="12"
                ><v-btn disabled>Update</v-btn></v-col
              >-->
            </v-row></v-tab-item
          >

          <v-tab-item>
            <v-row justify="center">
              <v-col align="center" cols="12">
                <v-list dense>
                  <v-list-item
                    v-for="(author, index) in authors"
                    :key="'author' + index"
                  >
                    <v-list-item-content>
                      <v-list-item-title>{{ author.name }}</v-list-item-title
                      ><v-list-item-subtitle>{{
                        author.role
                      }}</v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item
                    v-for="(developer, index) in developers"
                    :key="'developer' + index"
                  >
                    <v-list-item-content>
                      <v-list-item-title>{{ developer.name }}</v-list-item-title
                      ><v-list-item-subtitle>{{
                        developer.role
                      }}</v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item>
                  <!--
                  <v-list-item
                    v-for="(tester, index) in testers"
                    :key="'tester' + index"
                  >
                    <v-list-item-content>
                      <v-list-item-title>{{ tester.name }}</v-list-item-title
                      ><v-list-item-subtitle>{{
                        tester.role
                      }}</v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item>-->
                </v-list>
              </v-col>

              <v-col align="center" cols="12">
                <p>
                  Made with <span style="color: #e25555">&#9829;</span> in Italy
                </p>
              </v-col>
            </v-row>
          </v-tab-item>
        </v-tabs>
      </v-card-text>
      <v-card-actions>
        <v-btn href="https://metropolis.scienze.univr.it/" target="_blank" icon
          ><v-icon>mdi-web</v-icon></v-btn
        >
        <v-spacer></v-spacer>
        <v-btn @click="close" color="primary" text>Close</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  name: "About",
  props:["version"],
  data: () => ({
    tab: 1,
    js_dependencies: [
      "VueJS",
      "vuetify",
      "dygraphs",
      "socketio",
      "vuex",
      "vue-ellipse-progress",
      "flaticon"
    ],
    python_dependencies: [
      "flask",
      "flask-socketio",
      "flask-restful",
      "pyyaml",
      "requests",
      "easyserial",
      "pycuteweb",
    ],
    authors: [{ name: "Andrea Calanca", role: "Project leader" }],
    developers: [
      { name: "Eldison Dimo", role: "Developer" },
      { name: "Rudy Vicario", role: "Developer" },
      { name: "Noé Murr", role: "Board software developer" },
      { name: "Matteo Meneghetti", role: "UI and board software developer" },
    ],
    testers: [
      { name: "Filippo Grotto", role: "Developer & tester" },
      { name: "Antonino Parisi", role: "Tester" },
      { name: "Nicola Assolini", role: "Tester" },
    ],
  }),
  computed: {
    show: {
      get() {
        return this.$store.getters["drawer/about"];
      },
      set() {
        this.$store.dispatch(
          "drawer/showAbout",
          !this.$store.getters["drawer/about"]
        );
      },
    },
  },
  methods: {
    close() {
      this.$store.dispatch("drawer/showAbout", false);
    },
  },
};
</script>
